/*
    assemble.c
    Ƿ 
    2009.4.11
*/

# include "header/global.h" 
# include "header/assemble.h" 

/*  һֽڵĲ  */
uint8_t assemble(struct instruction* insn){
    const struct iformat* itable ;
    
    itable = instructions[insn->opcode] ;
    for ( ; itable->opcode != -1 ; itable++ ) {
        int test = ~insn->flags & itable->flags ;  /* Ա */
        int op = 0 ;  /*  */
        if (test == 0 && insn->operands != 0 &&
            insn->operands == itable->operands)
            do {
                test = ~insn->opt[op] & itable->opt[op] ; /* Բ */
                op++ ;
            } while (op < insn->operands && test == 0) ; 
            if (test == 0){
                int codeplus = 0 ;
                if (itable->attr == 001)
                    mod_flag = SET ;
                if (itable->attr == 002)
                    switch (insn->opv[0]){
                    case R_AL: case R_AX:
                        codeplus = 0 ; break ;
                    case R_CL: case R_CX:
                        codeplus = 1 ; break ;
                    case R_DL: case R_DX:
                        codeplus = 2 ; break ;
                    case R_BL: case R_BX: 
                        codeplus = 3 ; break ;
                    default: break ;
                    }
                
                return itable->code + codeplus ;
            }    
    }    
    error("޷ʶָ") ;
}

/*  ز  */
uint32_t expand_token(struct box* info)
{
    uint32_t optype ;
    if (info->token == TOKEN_REG)
    switch (info->value) {
        case R_AH:
            optype = REG8 ; break ;
        case R_AL: 
            optype = REG_AL ; break ;
        case R_BH: case R_BL: 
        case R_CH: case R_DH:
            optype = REG8NA ; break ;
        case R_CL:
            optype = REG_CL ; break ;
        case R_DL:
            optype = REG_DL ; break ;
        case R_AX:
            optype = REG_AX ; break ;
        case R_BX:
            optype = REG16NA ; break ;
        case R_CX:
            optype = REG_CX ; break ;
        case R_BP:
            optype = REG16 ; break ;
        case R_CS:
            optype = REG_CS ; break ;
        case R_DS: case R_ES:
        case R_SS:  
            optype = REG_DESS ; break ;
        default: break ;
    }
    else if (info->token == TOKEN_LAB || info->token == TOKEN_EXP){ 
        optype = IMMEDIATE ;
        dis_flag = SET ;
    }
    else if ( info->token == TOKEN_IMME){
        optype = IMMEDIATE ;
        imm_flag = SET ;
    }
    else if (info->token == TOKEN_ID)
        ; /*  ɶҲ  */
    else error("޷ʶTOKEN") ;
    
    return optype ;
}

uint8_t modrm( struct instruction* insn, uint8_t code ) 
{
    int value = 0 ;
    uint8_t op = 0 ;
    int operand[3] = {0,0,0} ;
    for ( ; op < insn->operands ; op++) {
        switch ( insn->opv[op] ){
            case R_AL: case R_AX: case R_ES:
                operand[op] += 0 ;
                break ;
            case R_CL: case R_CX: case R_CS:
                operand[op] += 1 ;
                break ;
            case R_DL: case R_DX: case R_SS:
                operand[op] += 2 ;
                break ;
            case R_BL: case R_BX: case R_DS:
                operand[op] += 3 ;
                break ;
            case R_BP: case R_CH:
                operand[op] += 5 ;
                break ;
            default: break ;
        }
    }
    /*  жDλȷ...Direction (d) Bit  */
    if ( (code & 0x2) == 0) 
         value = operand[0] + (operand[1] << 3) ;
    else 
        value = (operand[0] << 3) + operand[1] ;
    return value + 0xC0 ;
}
