/*
    init.h
    initļͷ 
    2009.4.12
*/

# include "x86.h"

extern int insert(char* s, int tok, int val) ;

struct box keywords[] = {
    /* REG */
    "al", TOKEN_REG, R_AL,
    "bl", TOKEN_REG, R_BL,
    "cl", TOKEN_REG, R_CL,
    "dl", TOKEN_REG, R_DL,
    "ax", TOKEN_REG, R_AX,
    "bx", TOKEN_REG, R_BX,
    "cx", TOKEN_REG, R_CX,
    "bp", TOKEN_REG, R_BP,
    "cs", TOKEN_REG, R_CS,
    "ds", TOKEN_REG, R_DS,
    "es", TOKEN_REG, R_ES,
    /* SPECIAL */
    "cpu",  TOKEN_DEC, D_CPU,
    "base", TOKEN_DEC, D_BASE,
    "times", TOKEN_PREFIX, P_TIMES,
    "db", TOKEN_SPECIAL, S_BITS8,
    "dw", TOKEN_SPECIAL, S_BITS16,
    "dd", TOKEN_SPECIAL, S_BITS32,
    "short", TOKEN_SPECIAL, S_SHORT,
    "near",  TOKEN_SPECIAL, S_NEAR,
    "far",   TOKEN_SPECIAL, S_FAR,
    "byte",  TOKEN_SPECIAL, S_BYTE,
    "word",  TOKEN_SPECIAL, S_WORD,
    "dword", TOKEN_SPECIAL, S_DWORD,
    /* INSN */
    "call", TOKEN_INSN, CALL,
    "int", TOKEN_INSN, INT,
    "jmp", TOKEN_INSN, JMP,
    "mov", TOKEN_INSN, MOV,
    "ret", TOKEN_INSN, RET,
    0,     0,  
} ;


