/*
    expr.c
    ʽ 
    2009.4.1
*/

# include "header/global.h"
# include "header/expr.h"

/*  ʽ  */
int expr(char* str)
{
    char ch, opr ;
    int value = 0 ;
    top_c = top_i= -1 ;  /* ÿջ */

    while (ch = *str) {
        switch (ch){
            case '0':case '1':case '2':case '3':case '4':
            case '5':case '6':case '7':case '8':case '9':
                value = ch - '0' ;
                while (isdigit(*++str))
                    value = value * 10 + (*str - '0') ;
                push_i(value) ;
                break ;
            case '$':
                if (*++str == '$'){
                    value = base_adr ;
                    str++ ;
                }
                else value = base_adr + this_adr ;
                push_i(value) ;
                break ;
            case '(':
                push_c(ch) ;
                str++ ;
                break ;
            case '*':case '+':
            case '/':case '-':
                if (top_c == -1) push_c(ch) ;
                else {
                    opr = pop_c() ;
                    while ( priority(opr) >= priority(ch) ){
                        push_i( eval(opr) ) ;
                        opr = pop_c() ;
                    }
                    if (opr != -1) push_c(opr) ;
                    push_c(ch) ;    
                }
                str++ ;
                break ;
            case ')':
                opr = pop_c() ;
                while (opr != '('){
                    push_i( eval(opr) ) ;
                    opr = pop_c() ;
                }
                str++ ;
                break ;  
            default: break ;
        }
    }
    while (top_c != -1) {
        opr = pop_c() ;
        push_i( eval(opr) ) ;
    }
    
    return pop_i() ;
}

int eval(int op)
{
    int op1 = pop_i() ;
    int op2 = pop_i() ;
    int result = 0 ;
    
    switch(op){
        case '+':
            result = op2 + op1 ;
            break ;
        case '-':
            result = op2 - op1 ;
            break ;
        case '*':
            result = op2 * op1 ;
            break ;
        case '/':
            result = op2 / op1 ;
            break ;
        default:
            printf("޷ʶĲ") ;
            break ;
    }
    return result ;
}


/*  ȼ  */
int priority (char c)
{
    if (c == '*' || c == '/')   return 2 ;
    else if (c == '+' || c == '-') return 1 ;
    else return 0 ;
}

/*  charջ  */ 
void push_c(char c)
{
    if ( top_c == MAX - 1 )
        printf ("ջ") ;
    else {
        top_c++ ;
        c_stack[top_c] = c ;
    }
}
/*  intջ  */
void push_i(int c)
{
    if ( top_i == MAX - 1 )
        printf ("ջ") ;
    else {
        top_i++ ;
        i_stack[top_i] = c ;
    }
}

/*  charջ  */
char pop_c ()
{
    if ( top_c == -1 ) /* ջ */
        return -1 ;
    else {
        char item = c_stack[top_c] ;
        top_c-- ;
        return item ;
    }
}

/*  intջ  */
int pop_i ()
{
    if ( top_i == -1 ) /* ջ */
        return -1 ;
    else {
        int item = i_stack[top_i] ;
        top_i-- ;
        return item ;
    }
}
