/*
    X86ָ
    2009.3.2
*/

# include "header/global.h" 
# include "header/x86.h"
# include "header/assemble.h"

/*    
 *    \000   
 *    \001  ModR/M  
 *    \002  +r ָ븽ӼĴֵ(ʡmodr/m) 
 */

static const struct iformat I_CALL[] = {
    {CALL, 1, {IMMEDIATE,0,0,0,0}, 0xE8, 000, IF_8086},
    FORMAT_END
};

static const struct iformat I_INT[] = {
    {INT, 1, {IMMEDIATE,0,0,0,0}, 0xCD, 000, IF_8086},
    FORMAT_END
};
static const struct iformat I_JMP[] = {
    {JMP, 1, {IMMEDIATE|SHORT,0,0,0,0}, 0xEB, 000, IF_8086},
    FORMAT_END
};

static const struct iformat I_MOV[] = {
    {MOV, 2, {REG16,REG16,0,0,0}, 0x89, 001, IF_8086},
    {MOV, 2, {REG16,REG_SREG,0,0,0}, 0x8C, 001, IF_8086},
    {MOV, 2, {REG_SREG,REG16,0,0,0}, 0x8E, 001, IF_8086},
    {MOV, 2, {REG8,IMMEDIATE,0,0,0}, 0xB0, 002, IF_8086},
    {MOV, 2, {REG16,IMMEDIATE,0,0,0}, 0xB8, 002, IF_8086},
    FORMAT_END
};

static const struct iformat I_RET[] = {
    {RET, 0, {0,0,0,0,0}, 0xC3, 000, IF_8086},
    FORMAT_END
};


const struct iformat* const instructions[] = {
    I_CALL,
    I_INT,
    I_JMP,
    I_MOV, 
    I_RET,
};
